import es,usermsg,cfglib,gamethread,random

import psyco
psyco.full()

info = es.AddonInfo()
info['name'] = "Advanced Spawn Wave"
info['basename'] = "spawnwave"
info['version'] = "2.0.2"
info['authors'] = "MiB"
info['url'] = "http://www.warcraft-source.com"
info['description'] = "Advanced set of tools for respawning."

config = cfglib.AddonCFG(es.getAddonPath("spawnwave") + "/spawnwave_config.cfg")
config.text("*****************************")
config.text("*****Advanced Spawn Wave*****")
config.text("***********Config************")
config.text("*****************************")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("**Enable/Disable Settings**")
config.text("***************************")
ws_roundmsg = config.cvar("ws_roundmsg",1,"Enable/Disable telling every player at round start that spawn wave is enabled.")
ws_tell = config.cvar("ws_tell",1,"Enable/Disable telling the player that the player is going to respawn in a form of a count down.")
ws_respawn = config.cvar("ws_respawn",1,"Enable/Disable death respawning.")
ws_showplayers = config.cvar("ws_showplayers",0,"Enable/Disable showing the players how many players are alive on each team.")
ws_showplayers_msg_enabled = config.cvar("ws_showplayers_msg_enabled",0,"Enable/Disable showing a msg to all players how many players there are alive on each team")
ws_showplayers_hostname_enabled = config.cvar("ws_showplayers_hostname_enabled",0,"Enable/Disable Displaying alive players in your server name.")
ws_restrict = config.cvar("ws_restrict",1,"Enable/Disable the restrictions of respawning.")
ws_respawn_cmd = config.cvar("ws_respawn_cmd","<0>","Enable/Disable the respawning by command.\n// Set the value to set the commands.\n// Setting this variable to <0> disables this feature.\n// Example: ws_respawn_cmd <myspawn><respawn><!respawn>")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("***Restrictions Settings***")
config.text("***************************")
ws_restrict_mapfilter = config.cvar("ws_restrict_mapfilter","<0>","Set what maps you do not want ASW active on.\n// Format: <mapname><mapname>\n// Example: ws_restrict_mapfilter <aim_ag_texture2><de_dust2>")
ws_restrict_team = config.cvar("ws_restrict_team","<0>","Set to the team number for teams you don't want getting ASW. <2 = T/3 = CT>\n// Example: ws_restrict_team <3> or ws_restrict_team <2> or ws_restrict_team <2><3>")
ws_restrict_lives = config.cvar("ws_restrict_lives",0,"How many lives to players get?\n// Set to 0 to disable.")
ws_restrict_lives_cmd = config.cvar("ws_restrict_lives_cmd","<!lives><lives><mylives><!mylives>","What text do you want players to use to see how many lives they have left?")
ws_restrict_respawn_cmd = config.cvar("ws_restrict_respawn_cmd","<1><0>","Who can use the respawn commands? // 1 = Dead / 0 = Alive")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("***Show Players Settings***")
config.text("***************************")
ws_showplayers_msg_type = config.cvar("ws_showplayers_msg_type","hudhint","What type of msg do you want it to be? <hudhint/centermsg>")
ws_showplayers_hostname = config.cvar("ws_showplayers_hostname","My Server CTs:%s|Ts:%s","Set the wanted name for your server.\n// Note: The first %s is the alive CT count and the second %s is the alive T count.")
config.text(" ")
config.text(" ")
config.text("**************************")
config.text("*****Respawn Settings*****")
config.text("**************************")
ws_tell_type = config.cvar("ws_tell_type","centermsg","What should the count down be? <hudhint/centermsg>")
ws_time_type = config.cvar("ws_time_type","set","How do you want the time to respawn be? <set/random>\n// Note: When using the random setting ws_time/ws_ct_time/ws_t_time are the minimum settings.")
ws_time_mode = config.cvar("ws_time_mode","normal","How do you want the time to respawn be? <normal/team>\n// Normal = It will use the time settings from ws_time and ws_time_max.\n// Team = It will use the time settings from ws_time_ct/ws_time_ct_max and ws_time_t/ws_time_t_max.")
ws_time = config.cvar("ws_time",2,"How long you want the until the player respawns.")
ws_time_max = config.cvar("ws_time_max",5,"The max time you want the wait to be for players.")
ws_ct_time = config.cvar("ws_ct_time",2,"How long you want until the ct player respawns.")
ws_ct_time_max = config.cvar("ws_ct_time_max",5,"The max time you want the wait to be for ct players.")
ws_t_time = config.cvar("ws_t_time",2,"How long you want until the t player respawns.")
ws_t_time_max = config.cvar("ws_t_time_max",5,"The max time you want the wait to be for t players.")
config.text(" ")
config.text(" ")
config.text("*****************************")
config.text("*****Advanced Spawn Wave*****")
config.text("********End of Config********")
config.text("*****************************")
config.write()

wsplayers = {}

def load():
	config.execute()
	global ws_check
	ws_check = 0
	global ws_map
	ws_map = "<%s>"%es.ServerVar("eventscripts_currentmap")
	es.set("ws_version",info.version,info.description)
	es.makepublic("ws_version")
	es.msg("#multi","\x05[Spawn Wave] #greenAdvanced Spawn Wave #lightgreenby #greenShidobu #lightgreenis active on this server.")

def unload():
	es.msg("#multi","\x05[Spawn Wave] #greenAdvanced Spawn Wave #lightgreenby #greenShidobu #lightgreenis no longer active on this server.")

def es_map_start(ev):
	global ws_check
	ws_check = 0

def round_start(ev):
	global ws_check
	ws_check = 1
	ws_enabled = 1
	if ws_restrict == 1:
		if ws_map in str(ws_restrict_mapfilter):
			ws_enabled = 0
		if ws_restrict_lives != 0:
			for userid in es.getUseridList():
				if str(userid) in wsplayers:
					wsplayers[str(userid)]["lives"] = ws_restrict_lives
				if str(userid) not in wsplayers:
					wsplayers[str(userid)] = {}
					wsplayers[str(userid)]["lives"] = ws_restrict_lives
	if ws_enabled == 1:
		if ws_showplayers == 1:
			ShowPlayers()
		if ws_roundmsg == 1:
			es.msg("#multi","\x05[Spawn Wave] #greenAdvanced Spawn Wave #lightgreenby #greenShidobu #lightgreenis active on this server.")

def round_end(ev):
	global ws_check
	ws_check = 0

def player_activate(ev):
	if ev["userid"] not in wsplayers:
		wsplayers[ev["userid"]] = {}
		wsplayers[ev["userid"]]["lives"] = ws_restrict_lives

def player_spawn(ev):
	if ev["userid"] not in wsplayers:
		wsplayers[ev["userid"]] = {}
		wsplayers[ev["userid"]]["lives"] = ws_restrict_lives

def player_death(ev):
	if ws_respawn == 1 and ws_check == 1:
		team = int(ev["es_userteam"])
		ws_enabled = 1
		if ws_restrict == 1:
			if ws_map in str(ws_restrict_mapfilter) or team < 2 or "<%s>"%team in str(ws_restrict_team):
				ws_enabled = 0
			if ws_restrict_lives != 0:
				lives = int(wsplayers[ev["userid"]]["lives"])
				if lives > 0:
					wsplayers[ev["userid"]]["lives"] = lives - 1
					ShowLives(ev["userid"])
				else:
					ShowLives(ev["userid"])
					ws_enabled = 0
		if ws_enabled == 1:
			if ws_time_type == "random":
				if ws_time_mode == "normal": WaveSpawn(ev["userid"],random.randint(int(ws_time),int(ws_time_max)))
				elif ws_time_mode == "team":
					if team == 2: WaveSpawn(ev["userid"],random.randint(int(ws_t_time),int(ws_t_time_max)))
					else: WaveSpawn(ev["userid"],random.randint(int(ws_ct_time),int(ws_ct_time_max)))
			elif ws_time_type == "set":
				if ws_time_mode == "normal": WaveSpawn(ev["userid"],int(ws_time))
				elif ws_time_mode == "team":
					if team == 2: WaveSpawn(ev["userid"],int(ws_t_time))
					else: WaveSpawn(ev["userid"],int(ws_ct_time))

def player_say(ev):
	team = int(es.getplayerteam(ev["userid"]))
	ws_enabled = 1
	if ws_restrict == 1:
		if ws_map in str(ws_restrict_mapfilter):
			ws_enabled = 0
	if ws_enabled == 1 and team > 1:
		text = "<%s>"%ev["text"]
		if text in str(ws_restrict_lives_cmd):
			ShowLives(ev["userid"])
		if str(ws_respawn_cmd) != "<0>" and text in str(ws_respawn_cmd):
			ws_enabled = 1
			if ws_restrict == 1:
				if ws_restrict_lives != 0:
					lives = int(wsplayers[ev["userid"]]["lives"])
					if lives > 0:
						wsplayers[ev["userid"]]["lives"] = int(lives) - 1
						ShowLives(ev["userid"])
					else:
						ShowLives(ev["userid"])
						ws_enabled = 0
				status = "<%s>"%es.getplayerprop(ev["userid"],"CCSPlayer.baseclass.pl.deadflag")
				team = "<%s>"%team
				if status not in str(ws_restrict_respawn_cmd) or team in str(ws_restrict_team):
					ws_enabled = 0
			if ws_enabled == 0:
				es.tell(ev["userid"],"#multi","\x05[Spawn Wave] #greenSorry, but the command #lightgreen%s #greenis restricted from you at the moment."%ev["text"])
			if ws_enabled == 1:
				Respawn_Func(ev["userid"])

def WaveSpawn(userid,time):
	if ws_check == 1 and ws_respawn == 1:
		if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 1:
			time -= 1
			if ws_tell == 1:
				if ws_tell_type == "hudhint": usermsg.hudhint(userid,"[Spawn Wave] You will respawn in %s seconds."%time)
				if ws_tell_type == "centermsg": es.centertell(userid,"[Spawn Wave] You will respawn in %s seconds."%time)
			if time > 0: gamethread.delayed(1,WaveSpawn,(userid,time))
			if time == 0: Respawn_Func(userid)

def Respawn_Func(userid):
	if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 1:
		es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
		es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
	gamethread.delayed(0.1,es.spawnplayer,userid)

def ShowPlayers():
	if ws_check == 1 and ws_showplayers == 1:
		if ws_showplayers == 1:
			tt = es.getplayercount()
			if tt > 0:
				c = es.getlivingplayercount(3)
				t = es.getlivingplayercount(2)
				if ws_showplayers_msg_enabled == 1:
					playerlist = es.getUseridList()
					for player in playerlist:
						if ws_showplayers_msg_type == "centermsg":
							es.centertell(player,"[Spawn Wave] CTs:%s|Ts:%s"%(c,t))
						if ws_showplayers_msg_type == "hudhint":
							usermsg.hudhint(player,"[Spawn Wave] CTs:%s|Ts:%s"%(c,t))
				if ws_showplayers_hostname_enabled == 1:
					ws_tmp = str(ws_showplayers_hostname)%(c,t)
					es.ServerVar("hostname").set(ws_tmp)
			gamethread.delayed(1,ShowPlayers,())

def ShowLives(userid):
	es.usermsg("create","showlives","KeyHintText")
	es.usermsg("write","byte","showlives",1)
	es.usermsg("write","string","showlives","[Spawn Wave] Lives Left: %s"%wsplayers[userid]["lives"])
	es.usermsg("send","showlives",userid)
	es.usermsg("delete","showlives")